function WeekKeys.WeekKeys.Friend(msg,sender)
    local command, text = strsplit(" ",msg,2)
    if msg == "request" then
        local char
        local str = WeekKeys.DB.GetAll(WeekKeysDB.Characters)
        while str and str:len() > 0 do
            char, str = strsplit("_",str,2)
            WeekKeys.BNAddMsg("WeekKeys","update2 "..char,sender)
        end
    elseif command == "update2" then
        local char
        if not WeekKeys.FriendBattleTag[sender] then
            local i = 1
            while C_BattleNet.GetFriendAccountInfo(i) do
                local friend = C_BattleNet.GetFriendAccountInfo(i)
                local id = friend.gameAccountInfo.gameAccountID
                local battleTag = friend.battleTag
                if id then
                    WeekKeys.FriendBattleTag[id] = battleTag
                    WeekKeys.BNAddMsg("WeekKeys","request",id)
                end
                i = i + 1
            end
        end
        WeekKeysDB.Friends[WeekKeys.FriendBattleTag[sender]] = WeekKeysDB.Friends[WeekKeys.FriendBattleTag[sender]] or {}
        while text and text:len() > 0 do
            char, text = strsplit("_",text,2)
            WeekKeys.DB.SaveVars(WeekKeysDB.Friends[WeekKeys.FriendBattleTag[sender]],WeekKeys.Convert.StringToVars(char,WeekKeys.FriendBattleTag[sender]))
        end
    end
end
WeekKeys.frame = CreateFrame("frame")
WeekKeys.frame:RegisterEvent("BN_CHAT_MSG_ADDON")
WeekKeys.frame:SetScript("OnEvent",function(self, event, prefix, text, channel ,id)
    if WeekKeys[prefix] then
        WeekKeys[prefix].Friend(text,id)
    end
end)
local prefix = {}
local message = {}
local target = {}
function WeekKeys.BNAddMsg(pref,msg,tar)
    if not prefix or not msg or not target or msg == "" then
        return
    end
    prefix[#prefix+1] = pref
    message[#message+1] = msg
    target[#target+1] = tar
end
function WeekKeys.BNSend()
    if #prefix == 0 then
        return
    end
    BNSendGameData(target[1],prefix[1],message[1])
    tremove(prefix,1)
    tremove(message,1)
    tremove(target,1)
end

local hand = C_Timer.NewTicker(0.2, WeekKeys.BNSend)